// Code based on XMLHttpRequest example code (C) Apple Inc.

var req;
var action = 0;
var page = 0;
var pages = 0;
var song = 0;
var song_prev = 0;

// retrieve text of an XML document element, including
// elements using namespaces
function getElementTextNS(prefix, local, parentElem, index) {
    var result = "";
    if (prefix && isIE) {
        // IE/Windows way of handling namespaces
        result = parentElem.getElementsByTagName(prefix + ":" + local)[index];
    } else {
        // the namespace versions of this method 
        // (getElementsByTagNameNS()) operate
        // differently in Safari and Mozilla, but both
        // return value with just local name, provided 
        // there aren't conflicts with non-namespace element
        // names
        result = parentElem.getElementsByTagName(local)[index];
    }
    if (result) {
        // get text, accounting for possible
        // whitespace (carriage return) text nodes 
        if (result.childNodes.length > 1) {
            return result.childNodes[1].nodeValue;
        } else {
            return result.firstChild.nodeValue;	      
        }
    } else {
        return "n/a";
    }
}

function loadXMLDoc(url, act) {
  req = false;
    // branch for native XMLHttpRequest object
    if(window.XMLHttpRequest) {
      try {
      req = new XMLHttpRequest();
        } catch(e) {
      req = false;
        }
    // branch for IE/Windows ActiveX version
    } else if(window.ActiveXObject) {
	try {
	  req = new ActiveXObject("Msxml2.XMLHTTP");
	} catch(e) {
	  try {
	      req = new ActiveXObject("Microsoft.XMLHTTP");
	  } catch(e) {
	      req = false;
	  }
    }
    }
  if(req) {
    action = act;
    req.onreadystatechange = processReqChange;
    req.open("GET", url, true);
    req.send("");
  }
}

function runAction () {

  if (action == 1)
    {
	loadXMLDoc("/xml?play="+song, -1);
	var cells = document.getElementById ("cells");

	//FIMXE: This doesn't hurt but it's not really correct either
	var tr = cells.childNodes[song_prev];
	tr.style.backgroundColor = "white";

	tr = cells.childNodes[song-(page*25)];
        tr.style.backgroundColor = "#def0f8";

	song_prev = song;
    }
  else if (action == 0)
    {
      var content = document.getElementById("div-list"); 
      var link = content.childNodes[0];

      while (link)
	{
	  content.removeChild(link);
	  link = content.childNodes[0];	
	}

      var entries = req.responseXML.getElementsByTagName("entries");
      var items = req.responseXML.getElementsByTagName("entry");
      var current_v = entries[0].getAttribute("current");

      var table = document.createElement("table");
      table.style.width = '95%';
      table.cellSpacing = '0';
      table.cellPadding = '0';

      var tbody = document.createElement("tbody");
      tbody.setAttribute("id","cells");
 
      table.appendChild(tbody); 
      content.appendChild(table);

      var pages = items.length / 25;

      var min = 0+(page*25);
      var max = min + 25; 

//      if (max > items.length) max = items.length;

      for (var i = min; i < max; i++)
	{
	  var tr, td, data; 

	  tr = document.createElement("tr"); 
	  tbody.appendChild(tr);
	  tr.style.color = "#2e5b7e";

	  if (current_v == i)
	    {
	      song_prev = i;
	      tr.style.backgroundColor = "#def0f8";
	    }
	  else
	    {
	      tr.style.backgroundColor = "white";
	    }

	  if (i < items.length)
	      data = document.createTextNode (i+1);
	  else
	      data = document.createTextNode ("--");

	  td = document.createElement("td");
	  td.style.textAlign = "right";
	  td.style.paddingLeft = "1em";
	  td.style.paddingRight = "4px";
	  td.style.borderRight = "1px solid #143853";
	  td.appendChild(data);
	  tr.appendChild(td);

	  if (i < items.length)
	    {
	      var button = document.createElement("button");
	      button.style.border = "1px solid #6e6e6e";
	      button.style.color = "#000000";
	      button.style.backgroundColor = "#eef5e9";
	      button.style.tableLayout = "fixed";
	      button.style.fontSize = "8px";
	      button.setAttribute("value", i);
	      button.setAttribute("onclick", "action = 1; song = "+i+"; runAction()");
	      button.appendChild(document.createTextNode("Play"));

	      td = document.createElement("td");
	      td.appendChild(button);
	      td.style.paddingLeft = "0.3em";
	      td.style.paddingRight = "0.3em";

	      tr.appendChild(td);


	      data = document.createTextNode (getElementTextNS("", "artist", items[i], 0)); 
	      td = document.createElement("td");
	      td.appendChild(data);
	      td.style.paddingLeft = "1em";
	      td.style.paddingRight = "1em";

	      tr.appendChild(td);

	      data = document.createTextNode (getElementTextNS("", "album", items[i], 0)); 
	      td = document.createElement("td");
	      td.appendChild(data);
	      td.style.paddingLeft = "1em";
	      td.style.paddingRight = "1em";

	      tr.appendChild(td);

	      data = document.createTextNode (getElementTextNS("", "title", items[i], 0)); 
	      td = document.createElement("td");
	      td.appendChild(data);
	      td.style.paddingLeft = "1em";
	      td.style.paddingRight = "1em";

	      tr.appendChild(td);

	      data = document.createTextNode (getElementTextNS("", "time", items[i], 0)); 
	      td = document.createElement("td");
	      td.appendChild(data);
	      td.style.paddingLeft = "1em";
	      td.style.paddingRight = "1em";
	      td.style.textAlign = "right";
	      td.style.fontFamily = "Monospace, Mono";

	      tr.appendChild(td);
	    }
	}

	  tbody.appendChild(tr);
      }

      for (var i = 0; i < pages; i++)
	{
	    var button = document.createElement("input");
	    button.setAttribute("type","button");
	    button.setAttribute("value","Page "+(i+1));
	    button.setAttribute("onclick","action = 0; page = '"+i+"'; runAction()");

	    button.style.border = "1px solid #6e6e6e";
	    button.style.color = "#000000";
	    button.style.backgroundColor = "#eef5e9";
	    button.style.tableLayout = "fixed";
	    button.style.marginRight = "1em";
	    button.style.marginTop = "1em";

	    content.appendChild (button);
	}
}

function processReqChange() {
    // only if req shows "loaded"
    if (req.readyState == 4) {
        // only if "OK"
        if (req.status == 200) {
	    runAction (action); 
        } else {
            alert("There was a problem retrieving the XML data: " + req.statusText);
        }
    }
}


