/* bmp_path_bar.h 
 *
 *
 * based on:
 *
 *
 * gtkpathbar.h
 * Copyright (C) 2004  Red Hat, Inc.,  Jonathan Blandford <jrb@gnome.org>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef __BMP_PATH_BAR__
#define __BMP_PATH_BAR__

#include <gtk/gtk.h>

G_BEGIN_DECLS

typedef struct _BmpPathBar      BmpPathBar;
typedef struct _BmpPathBarClass BmpPathBarClass;


#define BMP_TYPE_PATH_BAR                 (bmp_path_bar_get_type ())
#define BMP_PATH_BAR(obj)                 (G_TYPE_CHECK_INSTANCE_CAST ((obj), BMP_TYPE_PATH_BAR, BmpPathBar))
#define BMP_PATH_BAR_CLASS(klass)         (G_TYPE_CHECK_CLASS_CAST ((klass), BMP_TYPE_PATH_BAR, BmpPathBarClass))
#define BMP_IS_PATH_BAR(obj)              (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BMP_TYPE_PATH_BAR))
#define BMP_IS_PATH_BAR_CLASS(klass)      (G_TYPE_CHECK_CLASS_TYPE ((klass), BMP_TYPE_PATH_BAR))
#define BMP_PATH_BAR_GET_CLASS(obj)       (G_TYPE_INSTANCE_GET_CLASS ((obj), BMP_TYPE_PATH_BAR, BmpPathBarClass))

struct _BmpPathBar
{
  GtkContainer parent;

  gchar *root_path;
  GdkPixbuf *root_icon;

  GList *button_list;
  GList *first_scrolled_button;
  GList *fake_root;
  GtkWidget *up_slider_button;
  GtkWidget *down_slider_button;
  guint settings_signal_id;
  gint icon_size;
  gint16 slider_width;
  gint16 spacing;
  gint16 button_offset;
  guint timer;
  guint slider_visible : 1;
  guint need_timer     : 1;
  guint ignore_click   : 1;
  guint scrolling_up   : 1;
  guint scrolling_down : 1;
};

struct _BmpPathBarClass
{
  GtkContainerClass parent_class;

  void (* path_clicked) (BmpPathBar  *path_bar,
			 gchar       *file_path,
			 gchar       *child_path,
			 gboolean     child_is_hidden);
};

GType    bmp_path_bar_get_type (void) G_GNUC_CONST;

gboolean _bmp_path_bar_set_path        (BmpPathBar         *path_bar,
					gchar              *file_path,
					gboolean            keep_trail,
					GError            **error);

void     _bmp_path_bar_up              (BmpPathBar *path_bar);
void     _bmp_path_bar_down            (BmpPathBar *path_bar);

G_END_DECLS

#endif
