#include <gtk/gtk.h>

/* Designate dropped data types that we know and care about */
enum {
    BMP_DROP_QUERY,
    BMP_DROP_PLAINTEXT,
    BMP_DROP_URLENCODED,
    BMP_DROP_STRING,
};

/* Drag data format listing for gtk_drag_dest_set() */
static const GtkTargetEntry bmp_drop_types[] = {
    {"application/x-bmpx-db-query", 0, BMP_DROP_QUERY},
    {"text/plain",		    0, BMP_DROP_PLAINTEXT},
    {"text/uri-list",		    0, BMP_DROP_URLENCODED},
    {"STRING",			    0, BMP_DROP_STRING},
};

#define bmp_drag_dest_set(widget) \
    gtk_drag_dest_set(widget, \
		      GTK_DEST_DEFAULT_MOTION | GTK_DEST_DEFAULT_DROP, \
		      bmp_drop_types, 4, \
                      GDK_ACTION_COPY | GDK_ACTION_MOVE)

/* DnD between library/bookmarks */

typedef struct _DNDQueryTuple DNDQueryTuple;

struct _DNDQueryTuple {
    gchar *name;
    gchar *uri;
};
